package main

import (
	"encoding/base64"
	"encoding/hex"
	"io"
	"os"

	"surdeus.su/core/cli/mtool"
	"surdeus.su/util/gore/enc"
)

var root = mtool.T("gore").Subs(
	mtool.T("encode").Subs(
		enc.NewEncodeTool(
			"hex",
			hex.NewEncoder,
		),
		enc.NewEncodeTool(
			"b64",
			func(w io.Writer) io.Writer {
				return base64.NewEncoder(
					base64.StdEncoding,
					w,
				)
			},
		),
	),
)

func main() {
	root.Run(os.Args[1:])
}
